> ## Documentation Index
> Fetch the complete documentation index at: https://doc.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Update client domain



## OpenAPI

````yaml /api-reference/management.json put /v1/client-domains/{client_domain_id}
openapi: 3.0.1
info:
  description: >-
    Configuration endpoints for the Extole platform: campaigns, components,
    audiences, persons, rewards, reporting, integrations setup, and
    administrative tooling.
  title: Management API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Audiences
  - name: Authentication
  - name: Batch Jobs
  - name: Blocks
  - name: Campaigns
  - name: Components
  - name: Components Settings
  - name: Domains
  - name: Email
  - name: Erasure
  - name: Event Streams
  - name: File Validation Monitors
  - name: Optout
  - name: Profiles
  - name: Promotion Links
  - name: Report Schedules
  - name: Report Types
  - name: Reports
  - name: Reward Suppliers
  - name: Security Keys
  - name: Settings
  - name: User Notifications
  - name: User Subscriptions
  - name: Users
  - name: Webhooks
paths:
  /v1/client-domains/{client_domain_id}:
    put:
      tags:
        - Domains
      summary: Update client domain
      operationId: updateClientDomain
      parameters:
        - in: path
          name: client_domain_id
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            example:
              cname_target: cname_target
              name: name
              proxy: true
              redirect_client_domain_id: redirect_client_domain_id
              ssl_certificate: ssl_certificate
              ssl_certificate_chain: ssl_certificate_chain
              ssl_generation_policy: DISABLED
              ssl_private_key: ssl_private_key
            schema:
              $ref: '#/components/schemas/ClientDomainUpdateRequest'
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ClientDomainResponse'
          description: Successful response
        '400':
          content:
            application/json:
              examples:
                binding_error:
                  $ref: '#/components/examples/binding_error'
                client_domain_not_found:
                  $ref: '#/components/examples/client_domain_not_found'
                client_domain_redirect_generates_loop:
                  $ref: '#/components/examples/client_domain_redirect_generates_loop'
                cname_target_duplicate:
                  $ref: '#/components/examples/cname_target_duplicate'
                cname_target_invalid:
                  $ref: '#/components/examples/cname_target_invalid'
                cname_target_invalid_format:
                  $ref: '#/components/examples/cname_target_invalid_format'
                cname_target_not_applicable_for_extole_domains:
                  $ref: >-
                    #/components/examples/cname_target_not_applicable_for_extole_domains
                invalid_client_domain:
                  $ref: '#/components/examples/invalid_client_domain'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_name:
                  $ref: '#/components/examples/invalid_name'
                invalid_null:
                  $ref: '#/components/examples/invalid_null'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                non_existent_redirect_client_domain_id:
                  $ref: '#/components/examples/non_existent_redirect_client_domain_id'
                proxy_requires_redirect_client_domain_id:
                  $ref: >-
                    #/components/examples/proxy_requires_redirect_client_domain_id
                ssl_certificate_invalid_domain:
                  $ref: '#/components/examples/ssl_certificate_invalid_domain'
                ssl_certificate_not_signed_by_chain:
                  $ref: '#/components/examples/ssl_certificate_not_signed_by_chain'
                ssl_chain_key_expired:
                  $ref: '#/components/examples/ssl_chain_key_expired'
                ssl_chain_key_not_yet_valid:
                  $ref: '#/components/examples/ssl_chain_key_not_yet_valid'
                ssl_key_chain_or_private_key_missing_or_invalid:
                  $ref: >-
                    #/components/examples/ssl_key_chain_or_private_key_missing_or_invalid
                ssl_key_invalid:
                  $ref: '#/components/examples/ssl_key_invalid'
                ssl_keys_not_allowed_for_extole_domain:
                  $ref: '#/components/examples/ssl_keys_not_allowed_for_extole_domain'
                ssl_private_key_invalid:
                  $ref: '#/components/examples/ssl_private_key_invalid'
                ssl_private_key_invalid_format:
                  $ref: '#/components/examples/ssl_private_key_invalid_format'
                ssl_private_key_missing:
                  $ref: '#/components/examples/ssl_private_key_missing'
                ssl_public_key_expired:
                  $ref: '#/components/examples/ssl_public_key_expired'
                ssl_public_key_not_yet_valid:
                  $ref: '#/components/examples/ssl_public_key_not_yet_valid'
                ssl_public_private_keys_mismatch:
                  $ref: '#/components/examples/ssl_public_private_keys_mismatch'
                ssl_self_signed_certificate_not_accepted:
                  $ref: >-
                    #/components/examples/ssl_self_signed_certificate_not_accepted
                unknown_client_domain:
                  $ref: '#/components/examples/unknown_client_domain'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    ClientDomainUpdateRequest:
      description: Body of a `PUT /v1/client-domains/{client_domain_id}` request.
      properties:
        cname_target:
          type: string
        name:
          type: string
        proxy:
          type: boolean
        redirect_client_domain_id:
          nullable: true
          type: string
        ssl_certificate:
          type: string
        ssl_certificate_chain:
          type: string
        ssl_generation_policy:
          enum:
            - DISABLED
            - GENERATE
            - GENERATE_FORCE
            - PROVIDED
          type: string
        ssl_private_key:
          type: string
      type: object
    ClientDomainResponse:
      properties:
        cname_target:
          type: string
        domain:
          type: string
        id:
          readOnly: true
          type: string
        is_extole_domain:
          type: boolean
        name:
          type: string
        proxy:
          type: boolean
        redirect_client_domain_id:
          type: string
        secure:
          type: boolean
        share_uri:
          type: string
        site_patterns:
          items:
            $ref: '#/components/schemas/ClientDomainGlobPatternResponse'
          type: array
        ssl_certificate:
          type: string
        ssl_certificate_chain:
          type: string
        ssl_generation_policy:
          enum:
            - DISABLED
            - GENERATE
            - GENERATE_FORCE
            - PROVIDED
          type: string
        ssl_private_key:
          type: string
      required:
        - cname_target
        - domain
        - id
        - is_extole_domain
        - name
        - proxy
        - redirect_client_domain_id
        - secure
        - share_uri
        - site_patterns
        - ssl_certificate
        - ssl_certificate_chain
        - ssl_generation_policy
        - ssl_private_key
      type: object
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    ClientDomainGlobPatternResponse:
      properties:
        pattern:
          type: string
        regex:
          type: string
        type:
          enum:
            - DOMAIN
            - GLOB
            - SUB_DOMAIN
          type: string
      type: object
  examples:
    binding_error:
      summary: binding_error
      value:
        code: binding_error
        http_status_code: 400
        message: Argument is not of the expected type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    client_domain_not_found:
      summary: client_domain_not_found
      value:
        code: client_domain_not_found
        http_status_code: 400
        message: Was unable to find client domain with ID
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    client_domain_redirect_generates_loop:
      summary: client_domain_redirect_generates_loop
      value:
        code: client_domain_redirect_generates_loop
        http_status_code: 400
        message: Client domain redirect generates loop
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    cname_target_duplicate:
      summary: cname_target_duplicate
      value:
        code: cname_target_duplicate
        http_status_code: 400
        message: The CNAME target is being used by another program
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    cname_target_invalid:
      summary: cname_target_invalid
      value:
        code: cname_target_invalid
        http_status_code: 400
        message: Invalid CNAME target domain
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    cname_target_invalid_format:
      summary: cname_target_invalid_format
      value:
        code: cname_target_invalid_format
        http_status_code: 400
        message: 'CNAME target has invalid format. Expected: *.extole.io or *.extole.com'
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    cname_target_not_applicable_for_extole_domains:
      summary: cname_target_not_applicable_for_extole_domains
      value:
        code: cname_target_not_applicable_for_extole_domains
        http_status_code: 400
        message: Can't set CNAME target for Extole domains
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_client_domain:
      summary: invalid_client_domain
      value:
        code: invalid_client_domain
        http_status_code: 400
        message: Invalid client domain
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_json:
      summary: invalid_json
      value:
        code: invalid_json
        http_status_code: 400
        message: JSON is invalid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_name:
      summary: invalid_name
      value:
        code: invalid_name
        http_status_code: 400
        message: The provided client name was invalid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_null:
      summary: invalid_null
      value:
        code: invalid_null
        http_status_code: 400
        message: The attribute may be omitted but not nullified
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_parameter:
      summary: invalid_parameter
      value:
        code: invalid_parameter
        http_status_code: 400
        message: Parameter is invalid.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    missing_request_body:
      summary: missing_request_body
      value:
        code: missing_request_body
        http_status_code: 400
        message: Missing request body
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    non_existent_redirect_client_domain_id:
      summary: non_existent_redirect_client_domain_id
      value:
        code: non_existent_redirect_client_domain_id
        http_status_code: 400
        message: Redirect client domain doesn't exist
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    proxy_requires_redirect_client_domain_id:
      summary: proxy_requires_redirect_client_domain_id
      value:
        code: proxy_requires_redirect_client_domain_id
        http_status_code: 400
        message: A proxy client domain requires a redirect_client_domain_id
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_certificate_invalid_domain:
      summary: ssl_certificate_invalid_domain
      value:
        code: ssl_certificate_invalid_domain
        http_status_code: 400
        message: SSL Certificate does not match client domain domain
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_certificate_not_signed_by_chain:
      summary: ssl_certificate_not_signed_by_chain
      value:
        code: ssl_certificate_not_signed_by_chain
        http_status_code: 400
        message: Certificate not signed by the chain
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_chain_key_expired:
      summary: ssl_chain_key_expired
      value:
        code: ssl_chain_key_expired
        http_status_code: 400
        message: Chain key expired
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_chain_key_not_yet_valid:
      summary: ssl_chain_key_not_yet_valid
      value:
        code: ssl_chain_key_not_yet_valid
        http_status_code: 400
        message: Chain key chain not yet valid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_key_chain_or_private_key_missing_or_invalid:
      summary: ssl_key_chain_or_private_key_missing_or_invalid
      value:
        code: ssl_key_chain_or_private_key_missing_or_invalid
        http_status_code: 400
        message: One of the SSL keys (public, chain, private) is missing or invalid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_key_invalid:
      summary: ssl_key_invalid
      value:
        code: ssl_key_invalid
        http_status_code: 400
        message: Invalid format for public key
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_keys_not_allowed_for_extole_domain:
      summary: ssl_keys_not_allowed_for_extole_domain
      value:
        code: ssl_keys_not_allowed_for_extole_domain
        http_status_code: 400
        message: Cannot specify SSL attributes for extole.io or extole.com domains
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_private_key_invalid:
      summary: ssl_private_key_invalid
      value:
        code: ssl_private_key_invalid
        http_status_code: 400
        message: Invalid format for SSL private key
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_private_key_invalid_format:
      summary: ssl_private_key_invalid_format
      value:
        code: ssl_private_key_invalid_format
        http_status_code: 400
        message: Invalid format for SSL private key
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_private_key_missing:
      summary: ssl_private_key_missing
      value:
        code: ssl_private_key_missing
        http_status_code: 400
        message: SSL private key is missing
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_public_key_expired:
      summary: ssl_public_key_expired
      value:
        code: ssl_public_key_expired
        http_status_code: 400
        message: Public key expired
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_public_key_not_yet_valid:
      summary: ssl_public_key_not_yet_valid
      value:
        code: ssl_public_key_not_yet_valid
        http_status_code: 400
        message: Public Key not yet valid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_public_private_keys_mismatch:
      summary: ssl_public_private_keys_mismatch
      value:
        code: ssl_public_private_keys_mismatch
        http_status_code: 400
        message: Key pair public/private does not match
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    ssl_self_signed_certificate_not_accepted:
      summary: ssl_self_signed_certificate_not_accepted
      value:
        code: ssl_self_signed_certificate_not_accepted
        http_status_code: 400
        message: Self-signed certificates cannot be used
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    unknown_client_domain:
      summary: unknown_client_domain
      value:
        code: unknown_client_domain
        http_status_code: 400
        message: >-
          The provided client domain url is not associated with an existing
          client domain
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    method_unauthorized:
      summary: method_unauthorized
      value:
        code: method_unauthorized
        http_status_code: 401
        message: Unauthorized access to this endpoint
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    payment_required:
      summary: payment_required
      value:
        code: payment_required
        http_status_code: 402
        message: The access_token provided is associated with an unpaid account.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    access_denied:
      summary: access_denied
      value:
        code: access_denied
        http_status_code: 403
        message: >-
          The access_token provided is not permitted to access the specified
          resource.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    missing_access_token:
      summary: missing_access_token
      value:
        code: missing_access_token
        http_status_code: 403
        message: No access_token was provided with this request.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    unsupported_media_type:
      summary: unsupported_media_type
      value:
        code: unsupported_media_type
        http_status_code: 415
        message: Request had an unsupported or no media type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    too_many_requests:
      summary: too_many_requests
      value:
        code: too_many_requests
        http_status_code: 429
        message: >-
          The server is unable to process your request at the moment, please
          retry later.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
  securitySchemes:
    HEADER:
      in: header
      name: Authorization
      type: apiKey
      x-bearer-format: bearer
    QUERY:
      in: query
      name: access_token
      type: apiKey
    COOKIE:
      in: cookie
      name: extole_token
      type: apiKey

````